/*
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2007 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: atsvc.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides atsvc (Task Scheduler) services.
 * 
 */
package msrpc;

import rpc.*;
import ndr.NdrObject;
import ndr.NetworkDataRepresentation;
import ndr.NdrException;
import ndr.NdrBuffer;
import ndr.NdrLong;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class atsvc extends Stub {

	public static final float VistaVersion = Float.valueOf("6.0").floatValue();
	public static final float XPVersion = Float.valueOf("5.1").floatValue();
	public static float WinVersion = XPVersion;

	/**
	 * atsvc pipe
	 */
	public static final int AT_ADD_JOB = 0x00;
	public static final int AT_DEL_JOB = 0x01;
	public static final int AT_ENUM_JOBS = 0x02;
	public static final int AT_QUERY_JOB = 0x03;

	/**
	 * Vista ITaskSchedulerService interface Constants
	 */
	public static final int SchRpcHighestVersion = 0x00;
	public static final int SchRpcRegisterTask = 0x01;
	public static final int SchRpcRetrieveTask = 0x02;
	public static final int SchRpcCreateFolder = 0x03;
	public static final int SchRpcSetSecurity = 0x04;
	public static final int SchRpcGetSecurity = 0x05;
	public static final int SchRpcEnumFolder = 0x06;
	public static final int SchRpcEnumTasks = 0x07;
	public static final int SchRpcEnumInstances = 0x08;
	public static final int SchRpcGetInstanceInfo = 0x09;
	public static final int SchRpcStopInstance = 0x0a;
	public static final int SchRpcStop = 0x0b;
	public static final int SchRpcRun = 0x0c;
	public static final int SchRpcDelete = 0x0d;
	public static final int SchRpcRename = 0x0e;
	public static final int SchRpcScheduledRuntimes = 0x0f;
	public static final int SchRpcGetLastRunInfo = 0x10;
	public static final int SchRpcGetTaskInfo = 0x11;

	/**
	 * Job flags
	 */
	public static final int JOB_PERIODIC = 0x01;
	public static final int JOB_EXEC_ERR = 0x02;
	public static final int JOB_RUNS_TODAY = 0x04;
	public static final int JOB_INCLUDE_TODAY = 0x08;
	public static final int JOB_NONINTERACTIVE = 0x10;

	/**
	 * Day of month bitmap values
	 */
	public static final int DAYSOFMONTH_1 = 0x00000001;
	public static final int DAYSOFMONTH_2 = 0x00000002;
	public static final int DAYSOFMONTH_3 = 0x00000004;
	public static final int DAYSOFMONTH_4 = 0x00000008;
	public static final int DAYSOFMONTH_5 = 0x00000010;
	public static final int DAYSOFMONTH_6 = 0x00000020;
	public static final int DAYSOFMONTH_7 = 0x00000040;
	public static final int DAYSOFMONTH_8 = 0x00000080;
	public static final int DAYSOFMONTH_9 = 0x00000100;
	public static final int DAYSOFMONTH_10 = 0x00000200;
	public static final int DAYSOFMONTH_11 = 0x00000400;
	public static final int DAYSOFMONTH_12 = 0x00000800;
	public static final int DAYSOFMONTH_13 = 0x00001000;
	public static final int DAYSOFMONTH_14 = 0x00002000;
	public static final int DAYSOFMONTH_15 = 0x00004000;
	public static final int DAYSOFMONTH_16 = 0x00008000;
	public static final int DAYSOFMONTH_17 = 0x00010000;
	public static final int DAYSOFMONTH_18 = 0x00020000;
	public static final int DAYSOFMONTH_19 = 0x00040000;
	public static final int DAYSOFMONTH_20 = 0x00080000;
	public static final int DAYSOFMONTH_21 = 0x00100000;
	public static final int DAYSOFMONTH_22 = 0x00200000;
	public static final int DAYSOFMONTH_23 = 0x00400000;
	public static final int DAYSOFMONTH_24 = 0x00800000;
	public static final int DAYSOFMONTH_25 = 0x01000000;
	public static final int DAYSOFMONTH_26 = 0x02000000;
	public static final int DAYSOFMONTH_27 = 0x04000000;
	public static final int DAYSOFMONTH_28 = 0x08000000;
	public static final int DAYSOFMONTH_29 = 0x10000000;
	public static final int DAYSOFMONTH_30 = 0x20000000;
	public static final int DAYSOFMONTH_31 = 0x40000000;

	/**
	 * Days of week bitmap values
	 */
	public static final int DAYSOFWEEK_MONDAY = 0x01;
	public static final int DAYSOFWEEK_TUESDAY = 0x02;
	public static final int DAYSOFWEEK_WEDNESDAY = 0x04;
	public static final int DAYSOFWEEK_THURSDAY = 0x08;
	public static final int DAYSOFWEEK_FRIDAY = 0x10;
	public static final int DAYSOFWEEK_SATURDAY = 0x20;
	public static final int DAYSOFWEEK_SUNDAY = 0x40;

	/**
	 * Vista Task Scheduler Error and Success Constants
	 */
	// The task is ready to run at its next scheduled time.
	public static final int SCHED_S_TASK_READY = 0x00041300;
	// The task is currently running.
	public static final int SCHED_S_TASK_RUNNING = 0x00041301;
	// The task will not run at the scheduled times because it has been
	// disabled.
	public static final int SCHED_S_TASK_DISABLED = 0x00041302;
	// The task has not yet run.
	public static final int SCHED_S_TASK_HAS_NOT_RUN = 0x00041303;
	// There are no more runs scheduled for this task.
	public static final int SCHED_S_TASK_NO_MORE_RUNS = 0x00041304;
	// One or more of the properties that are needed to run this task on a
	// schedule have not been set.
	public static final int SCHED_S_TASK_NOT_SCHEDULED = 0x00041305;
	// The last run of the task was terminated by the user.
	public static final int SCHED_S_TASK_TERMINATED = 0x00041306;
	// Either the task has no triggers or the existing triggers are disabled
	// or not set.
	public static final int SCHED_S_TASK_NO_VALID_TRIGGERS = 0x00041307;
	// Event triggers do not have set run times.
	public static final int SCHED_S_EVENT_TRIGGER = 0x00041308;
	// A task's trigger is not found.
	public static final int SCHED_E_TRIGGER_NOT_FOUND = 0x80041309;
	// One or more of the properties required to run this task have not been
	// set.
	public static final int SCHED_E_TASK_NOT_READY = 0x8004130A;
	// There is no running instance of the task.
	public static final int SCHED_E_TASK_NOT_RUNNING = 0x8004130B;
	// The Task Scheduler service is not installed on this computer.
	public static final int SCHED_E_SERVICE_NOT_INSTALLED = 0x8004130C;
	// The task object could not be opened.
	public static final int SCHED_E_CANNOT_OPEN_TASK = 0x8004130D;
	// The object is either an invalid task object or is not a task object.
	public static final int SCHED_E_INVALID_TASK = 0x8004130E;
	// No account information could be found in the Task Scheduler security
	// database for the task indicated.
	public static final int SCHED_E_ACCOUNT_INFORMATION_NOT_SET = 0x8004130F;
	// Unable to establish existence of the account specified.
	public static final int SCHED_E_ACCOUNT_NAME_NOT_FOUND = 0x80041310;
	// Corruption was detected in the Task Scheduler security database;
	// the database has been reset.
	public static final int SCHED_E_ACCOUNT_DBASE_CORRUPT = 0x80041311;
	// Task Scheduler security services are available only on Windows NT.
	public static final int SCHED_E_NO_SECURITY_SERVICES = 0x80041312;
	// The task object version is either unsupported or invalid.
	public static final int SCHED_E_UNKNOWN_OBJECT_VERSION = 0x80041313;
	// The task has been configured with an unsupported combination of account
	// settings and run time options.
	public static final int SCHED_E_UNSUPPORTED_ACCOUNT_OPTION = 0x80041314;
	// The Task Scheduler Service is not running.
	public static final int SCHED_E_SERVICE_NOT_RUNNING = 0x80041315;
	// The task XML contains an unexpected node.
	public static final int SCHED_E_UNEXPECTEDNODE = 0x80041316;
	// The task XML contains an element or attribute from an unexpected
	// namespace.
	public static final int SCHED_E_NAMESPACE = 0x80041317;
	// The task XML contains a value which is incorrectly formatted or
	// out of range.
	public static final int SCHED_E_INVALIDVALUE = 0x80041318;
	// The task XML is missing a required element or attribute.
	public static final int SCHED_E_MISSINGNODE = 0x80041319;
	// The task XML is malformed.
	public static final int SCHED_E_MALFORMEDXML = 0x8004131A;
	// The task is registered, but not all specified triggers will start the
	// task.
	public static final int SCHED_S_SOME_TRIGGERS_FAILED = 0x0004131B;
	// The task is registered, but may fail to start. Batch logon privilege
	// needs
	// to be enabled for the task principal.
	public static final int SCHED_S_BATCH_LOGON_PROBLEM = 0x0004131C;
	// The task XML contains too many nodes of the same type.
	public static final int SCHED_E_TOO_MANY_NODES = 0x8004131D;
	// The task cannot be started after the trigger end boundary.
	public static final int SCHED_E_PAST_END_BOUNDARY = 0x8004131E;
	// An instance of this task is already running.
	public static final int SCHED_E_ALREADY_RUNNING = 0x8004131F;
	// The task will not run because the user is not logged on.
	public static final int SCHED_E_USER_NOT_LOGGED_ON = 0x80041320;
	// The task image is corrupt or has been tampered with.
	public static final int SCHED_E_INVALID_TASK_HASH = 0x80041321;
	// The Task Scheduler service is not available.
	public static final int SCHED_E_SERVICE_NOT_AVAILABLE = 0x80041322;
	// The Task Scheduler service is too busy to handle your request.
	// Please try again later.
	public static final int SCHED_E_SERVICE_TOO_BUSY = 0x80041323;
	// The Task Scheduler service attempted to run the task, but the task did
	// not
	// run due to one of the constraints in the task definition.
	public static final int SCHED_E_TASK_ATTEMPTED = 0x80041324;
	// The Task Scheduler service has asked the task to run.
	public static final int SCHED_S_TASK_QUEUED = 0x00041325;
	// The task is disabled.
	public static final int SCHED_E_TASK_DISABLED = 0x80041326;
	// The task has properties that are not compatible with earlier
	// versions of Windows.
	public static final int SCHED_E_TASK_NOT_V1_COMPAT = 0x80041327;
	// The task settings do not allow the task to start on demand.
	public static final int SCHED_E_START_ON_DEMAND = 0x80041328;

	// atsvc syntax
	public static final String MY_AT_SYNTAX = "1ff70682-0a51-30e8-076d-740be8cee98b:1.0";
	// ITaskSchedulerService syntax
	public static final String MY_TS_SYNTAX = "86d35949-83c9-4044-b424-db363231fd0c:1.0";

	public String getSyntax() {
		// We don't need to support this yet since Vista can still use atsvc
		// if (WinVersion >= VistaVersion)
		// return MY_TS_SYNTAX;
		// else
		return MY_AT_SYNTAX;
	}

	/**
	 * AT_INFO structure class
	 * 
	 * Properties:
	 * 
	 * job_time - Specifies a value that indicates the time of day at which the
	 * job is scheduled to run. The time is the local time at a computer on
	 * which the schedule service is running; it is measured from midnight, and
	 * is expressed in milliseconds.
	 * 
	 * days_of_month - Specifies a DWORD value that contains a set of bit flags
	 * representing the days of the month. For each bit that is set, the
	 * scheduled job will run at the time specified by the job_time member, on
	 * the corresponding day of the month. Bit 0 corresponds to the first day of
	 * the month, and so on. The value of the bitmask is zero if the job was
	 * scheduled to run only once, at the first occurrence of job_time.
	 * 
	 * days_of_week - Specifies a variable that contains a set of bit flags
	 * representing the days of the week. For each bit that is set, the
	 * scheduled job will run at the time specified by the job_time member, on
	 * the corresponding day of the week. Bit 0 corresponds to Monday, and so
	 * on. The value of the bitmask is zero if the job was scheduled to run only
	 * once, at the first occurrence of job_time.
	 * 
	 * flags - Specifies a variable that contains a set of bit flags describing
	 * job properties. When you submit a job using a call to the ScheduleJobAdd
	 * function, you can specify one of the following values:
	 * 
	 * JOB_RUN_PERIODICALLY - If you set this flag, the job runs, and continues
	 * to run, on each day for which a corresponding bit is set in the
	 * days_of_month or days_of_week member. The job is not deleted after it
	 * executes. If this flag is clear, the job runs only once for each bit set
	 * in these members. The job is deleted after it executes once.
	 * 
	 * JOB_ADD_CURRENT_DATE - If you set this flag, the job executes at the
	 * first occurrence of job_time at the computer where the job is queued.
	 * Setting this flag is equivalent to setting the bit for the current day in
	 * the days_of_month member.
	 * 
	 * JOB_NONINTERACTIVE - If you set this flag, the job does not run
	 * interactively. If this flag is clear, the job runs interactively.
	 * 
	 * Retrieving job information: When you call ScheduleJobGetInfo to retrieve
	 * job information, the function can return one or more of the following
	 * values:
	 * 
	 * JOB_RUN_PERIODICALLY - This flag is equal to its original value, that is,
	 * the value when the job was submitted.
	 * 
	 * JOB_EXEC_ERROR - If this flag is set, it indicates that the schedule
	 * service failed to successfully execute the job the last time it was
	 * scheduled to run.
	 * 
	 * JOB_RUNS_TODAY - If this flag is set, it indicates that the job is
	 * scheduled to execute on the current day; the value of the job_time member
	 * is greater than the current time of day at the computer where the job is
	 * queued.
	 * 
	 * JOB_NONINTERACTIVE - This flag bit is equal to its original value, that
	 * is, the value when the job was submitted.
	 * 
	 * command - Unicode string that contains the name of the command, batch
	 * program, or binary file to execute.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class AtInfo extends NdrObject {

		public int job_time;
		public int days_of_month;
		public byte days_of_week;
		public byte flags;
		public String command;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(job_time);
			_dst.enc_ndr_long(days_of_month);
			_dst.enc_ndr_small(days_of_week);
			_dst.enc_ndr_small(flags);
			_dst.enc_ndr_referent(command, 1);

			if (command != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(command);
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			job_time = (int) _src.dec_ndr_long();
			days_of_month = (int) _src.dec_ndr_long();
			days_of_week = (byte) _src.dec_ndr_small();
			flags = (byte) _src.dec_ndr_small();
			int _commandp = _src.dec_ndr_long();

			if (_commandp != 0) {
				_src = _src.deferred;
				command = _src.dec_ndr_string();
			}
		}
	}

	/**
	 * List of AT_INFO structures
	 */
	public static class EnumCtr extends NdrObject {

		public int entries_read;
		public AtInfo[] first_entry;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(entries_read);
			_dst.enc_ndr_referent(first_entry, 1);

			if (first_entry != null) {
				_dst = _dst.deferred;
				int _first_entrys = entries_read;
				_dst.enc_ndr_long(_first_entrys);
				int _first_entryi = _dst.index;
				_dst.advance(16 * _first_entrys);

				_dst = _dst.derive(_first_entryi);
				for (int _i = 0; _i < _first_entrys; _i++) {
					first_entry[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			entries_read = (int) _src.dec_ndr_long();
			int _first_entryp = _src.dec_ndr_long();

			if (_first_entryp != 0) {
				_src = _src.deferred;
				int _first_entrys = _src.dec_ndr_long();
				int _first_entryi = _src.index;
				_src.advance(16 * _first_entrys);

				if (first_entry == null) {
					if (_first_entrys < 0 || _first_entrys > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					first_entry = new AtInfo[_first_entrys];
				}
				_src = _src.derive(_first_entryi);
				for (int _i = 0; _i < _first_entrys; _i++) {
					if (first_entry[_i] == null) {
						first_entry[_i] = new AtInfo();
					}
					first_entry[_i].decode(_ndr, _src);
				}
			}
		}
	}

	/**
	 * Net Schedule Job Add class
	 * 
	 * Properties:
	 * 
	 * servername - constant string that specifies the DNS or NetBIOS name of
	 * the remote server on which the function is to execute. If this parameter
	 * is NULL, the local computer is used.
	 * 
	 * job_info - AtInfo object describing the job to submit.
	 * 
	 * job_id - job identifier for the newly submitted job. This entry is valid
	 * only if the function returns successfully.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class ScheduleJobAdd extends NdrObject {

		public int getOpnum() {
			return AT_ADD_JOB;
		}

		public int retval;
		public String servername;
		public AtInfo job_info;
		public int job_id;

		public ScheduleJobAdd(String servername, AtInfo job_info, int job_id) {
			this.servername = servername;
			this.job_info = job_info;
			this.job_id = job_id;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);
			}
			job_info.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			job_id = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Net Schedule Job Delete Class
	 * 
	 * Properties:
	 * 
	 * servername - A constant string that specifies the DNS or NetBIOS name of
	 * the remote server on which the function is to execute. If this parameter
	 * is NULL, the local computer is used.
	 * 
	 * min_job_id - Specifies a minimum job identifier. Jobs with a job
	 * identifier smaller than min_job_id will not be deleted.
	 * 
	 * max_job_id - Specifies a maximum job identifier. Jobs with a job
	 * identifier larger than max_job_id will not be deleted.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class ScheduleJobDel extends NdrObject {

		public int getOpnum() {
			return AT_DEL_JOB;
		}

		public int retval;
		public String servername;
		public int min_job_id;
		public int max_job_id;

		public ScheduleJobDel(String servername, int min_job_id, int max_job_id) {
			this.servername = servername;
			this.min_job_id = min_job_id;
			this.max_job_id = max_job_id;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);

			}
			_dst.enc_ndr_long(min_job_id);
			_dst.enc_ndr_long(max_job_id);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Net Schedule Job Enum class.
	 * 
	 * Lists the jobs queued on a specified computer. This function requires
	 * that the schedule service be started.
	 * 
	 * Properties:
	 * 
	 * servername -a constant string that specifies the DNS or NetBIOS name of
	 * the remote server on which the function is to execute.
	 * 
	 * ctr - buffer that receives the data. The return information is an array
	 * of AT_ENUM structures. The buffer is allocated by the system and must be
	 * freed using a single call to the NetApiBufferFree function. Note that you
	 * must free the buffer even if the function fails with ERROR_MORE_DATA.
	 * 
	 * preferred_max_len - a value that indicates the preferred maximum length
	 * of the returned data, in bytes. If you specify MAX_PREFERRED_LENGTH, the
	 * function allocates the amount of memory required for the data. If you
	 * specify another value in this parameter, it can restrict the number of
	 * bytes that the function returns. If the buffer size is insufficient to
	 * hold all entries, the function returns ERROR_MORE_DATA. For more
	 * information, see Network Management Function Buffers and Network
	 * Management Function Buffer Lengths.
	 * 
	 * total_entries - a value that receives the total number of entries that
	 * could have been enumerated from the current resume position. Note that
	 * applications should consider this value only as a hint.
	 * 
	 * resume_handle - a value that contains a resume handle which is used to
	 * continue a job enumeration. The handle should be zero on the first call
	 * and left unchanged for subsequent calls. If ResumeHandle is NULL, then no
	 * resume handle is stored.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class ScheduleJobEnum extends NdrObject {

		public int getOpnum() {
			return AT_ENUM_JOBS;
		}

		public int retval;
		public String servername;
		public EnumCtr ctr;
		public int preferred_max_len;
		public int total_entries;
		public NdrLong resume_handle;

		public ScheduleJobEnum(String servername, EnumCtr ctr,
				int preferred_max_len, int total_entries, NdrLong resume_handle) {
			this.servername = servername;
			this.ctr = ctr;
			this.preferred_max_len = preferred_max_len;
			this.total_entries = total_entries;
			this.resume_handle = resume_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);

			}
			ctr.encode(_ndr, _dst);
			_dst.enc_ndr_long(preferred_max_len);
			_dst.enc_ndr_referent(resume_handle, 1);
			if (resume_handle != null) {
				resume_handle.encode(_ndr, _dst);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			ctr.decode(_ndr, _src);
			total_entries = (int) _src.dec_ndr_long();
			int _resume_handlep = _src.dec_ndr_long();
			if (_resume_handlep != 0) {
				resume_handle.decode(_ndr, _src);

			}
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Net Schedule Job Get Info class.
	 * 
	 * Retrieves information about a particular job queued on a specified
	 * computer
	 * 
	 * Properties:
	 * 
	 * servername - constant string that specifies the DNS or NetBIOS name of
	 * the remote server on which the function is to execute. If this parameter
	 * is NULL, the local computer is used.
	 * 
	 * job_id - a value that indicates the identifier of the job for which to
	 * retrieve information.
	 * 
	 * job_info - buffer that receives the AT_INFO structure describing the
	 * specified job. This buffer is allocated by the system and must be freed
	 * using the NetApiBufferFree function.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class ScheduleJobGetInfo extends NdrObject {

		public int getOpnum() {
			return AT_QUERY_JOB;
		}

		public int retval;
		public String servername;
		public int job_id;
		public AtInfo job_info;

		public ScheduleJobGetInfo(String servername, int job_id, AtInfo job_info) {
			this.servername = servername;
			this.job_id = job_id;
			this.job_info = job_info;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);

			}
			_dst.enc_ndr_long(job_id);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _job_infop = _src.dec_ndr_long();
			job_info.decode(_ndr, _src);

			retval = (int) _src.dec_ndr_long();
		}
	}

}
