/*
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2007 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: samr.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides samr (Security Account Manager) services.
 * 
 */
package msrpc;

import rpc.*;
import ndr.*;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class samr extends Stub {

	public static final String MY_SYNTAX = "12345778-1234-abcd-ef00-0123456789ac:1.0";

	public String getSyntax() {
		return MY_SYNTAX;
	}

	/**
	 * samr pipe
	 */
	public static final int SAMR_CONNECT = 0x00;
	public static final int SAMR_CLOSE_HANDLE = 0x01;
	public static final int SAMR_SET_SEC_OBJ = 0x02;
	public static final int SAMR_QUERY_SEC_OBJ = 0x03;
	public static final int SAMR_SHUTDOWN_SAM_SVR = 0x04;
	public static final int SAMR_LOOKUP_DOM_IN_SAM_SVR = 0x05;
	public static final int SAMR_ENUM_DOMS_IN_SAM_SVR = 0x06;
	public static final int SAMR_OPEN_DOM = 0x07;
	public static final int SAMR_QUERY_INFO_DOM = 0x08;
	public static final int SAMR_SET_INFO_DOM = 0x09;
	public static final int SAMR_CREATE_GROUP_IN_DOM = 0x0A;
	public static final int SAMR_ENUM_GROUPS_IN_DOM = 0x0B;
	public static final int SAMR_CREATE_USER_IN_DOM = 0x0C;
	public static final int SAMR_ENUM_USERS_IN_DOM = 0x0D;
	public static final int SAMR_CREATE_ALIAS_IN_DOM = 0x0E;
	public static final int SAMR_ENUM_ALIASES_IN_DOM = 0x0F;
	public static final int SAMR_GET_ALIAS_MEMBERSHIP = 0x10;
	public static final int SAMR_LOOKUP_NAMES_IN_DOM = 0x11;
	public static final int SAMR_LOOKUP_IDS_IN_DOM = 0x12;
	public static final int SAMR_OPEN_GROUP = 0x13;
	public static final int SAMR_QUERY_INFO_GROUP = 0x14;
	public static final int SAMR_SET_INFO_GROUP = 0x15;
	public static final int SAMR_ADD_MEMBER_TO_GROUP = 0x16;
	public static final int SAMR_DEL_GROUP = 0x17;
	public static final int SAMR_REM_MEMBER_FROM_GROUP = 0x18;
	public static final int SAMR_GET_MEMBERS_IN_GROUP = 0x19;
	public static final int SAMR_SET_MEMBER_ATTRS_OF_GROUP = 0x1A;
	public static final int SAMR_OPEN_ALIAS = 0x1B;
	public static final int SAMR_QUERY_INFO_ALIAS = 0x1C;
	public static final int SAMR_SET_INFO_ALIAS = 0x1D;
	public static final int SAMR_DEL_ALIAS = 0x1E;
	public static final int SAMR_ADD_MEMBER_TO_ALIAS = 0x1F;
	public static final int SAMR_REM_MEMBER_FROM_ALIAS = 0x20;
	public static final int SAMR_GET_MEMBERS_IN_ALIAS = 0x21;
	public static final int SAMR_OPEN_USER = 0x22;
	public static final int SAMR_DEL_USER = 0x23;
	public static final int SAMR_QUERY_INFO_USER = 0x24;
	public static final int SAMR_SET_INFO_USER = 0x25;
	public static final int SAMR_CHANGE_PWD_USER = 0x26;
	public static final int SAMR_GET_GROUPS_FOR_USER = 0x27;
	public static final int SAMR_CONNECT2 = 0x39;
	public static final int SAMR_SET_INFO_USER2 = 0x3A;
	public static final int SAMR_SET_BOOT_KEY_INFO = 0x3B;
	public static final int SAMR_GET_BOOT_KEY_INFO = 0x3C;
	public static final int SAMR_CONNECT3 = 0x3D;
	public static final int SAMR_CONNECT4 = 0x3E;

	public static class SamrCloseHandle extends NdrObject {

		public int getOpnum() {
			return SAMR_CLOSE_HANDLE;
		}

		public int retval;
		public rpc.policy_handle handle;

		public SamrCloseHandle(rpc.policy_handle handle) {
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class SamrConnect2 extends NdrObject {

		public int getOpnum() {
			return SAMR_CONNECT2;
		}

		public int retval;
		public String system_name;
		public int access_mask;
		public rpc.policy_handle handle;

		public SamrConnect2(String system_name, int access_mask,
				rpc.policy_handle handle) {
			this.system_name = system_name;
			this.access_mask = access_mask;
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(system_name, 1);
			if (system_name != null) {
				_dst.enc_ndr_string(system_name);

			}
			_dst.enc_ndr_long(access_mask);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class SamrConnect4 extends NdrObject {

		public int getOpnum() {
			return SAMR_CONNECT4;
		}

		public int retval;
		public String system_name;
		public int unknown;
		public int access_mask;
		public rpc.policy_handle handle;

		public SamrConnect4(String system_name, int unknown, int access_mask,
				rpc.policy_handle handle) {
			this.system_name = system_name;
			this.unknown = unknown;
			this.access_mask = access_mask;
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(system_name, 1);
			if (system_name != null) {
				_dst.enc_ndr_string(system_name);

			}
			_dst.enc_ndr_long(unknown);
			_dst.enc_ndr_long(access_mask);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class SamrOpenDomain extends NdrObject {

		public int getOpnum() {
			return SAMR_OPEN_DOM;
		}

		public int retval;
		public rpc.policy_handle handle;
		public int access_mask;
		public rpc.sid_t sid;
		public rpc.policy_handle domain_handle;

		public SamrOpenDomain(rpc.policy_handle handle, int access_mask,
				rpc.sid_t sid, rpc.policy_handle domain_handle) {
			this.handle = handle;
			this.access_mask = access_mask;
			this.sid = sid;
			this.domain_handle = domain_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(access_mask);
			sid.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			domain_handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class SamrOpenUser extends NdrObject {

		public int getOpnum() {
			return SAMR_OPEN_USER;
		}

		public int retval;
		public rpc.policy_handle handle;
		public int access_mask;
		public int rid;
		public rpc.policy_handle user_handle;

		public SamrOpenUser(rpc.policy_handle handle, int access_mask, int rid,
				rpc.policy_handle user_handle) {
			this.handle = handle;
			this.access_mask = access_mask;
			this.rid = rid;
			this.user_handle = user_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(access_mask);
			_dst.enc_ndr_long(rid);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			user_handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class TypedRid extends NdrObject {

		public int rid;
		public int type;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(rid);
			_dst.enc_ndr_long(type);

		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			rid = (int) _src.dec_ndr_long();
			type = (int) _src.dec_ndr_long();

		}
	}

	public static class TypedRidArray extends NdrObject {

		public int count;
		public TypedRid[] groups;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(groups, 1);

			if (groups != null) {
				_dst = _dst.deferred;
				int _groupss = count;
				_dst.enc_ndr_long(_groupss);
				int _groupsi = _dst.index;
				_dst.advance(8 * _groupss);

				_dst = _dst.derive(_groupsi);
				for (int _i = 0; _i < _groupss; _i++) {
					groups[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _groupsp = _src.dec_ndr_long();

			if (_groupsp != 0) {
				_src = _src.deferred;
				int _groupss = _src.dec_ndr_long();
				int _groupsi = _src.index;
				_src.advance(8 * _groupss);

				if (groups == null) {
					if (_groupss < 0 || _groupss > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					groups = new TypedRid[_groupss];
				}
				_src = _src.derive(_groupsi);
				for (int _i = 0; _i < _groupss; _i++) {
					if (groups[_i] == null) {
						groups[_i] = new TypedRid();
					}
					groups[_i].decode(_ndr, _src);
				}
			}
		}
	}

	public static class SamrGetGroupsForUser extends NdrObject {

		public int getOpnum() {
			return SAMR_GET_GROUPS_FOR_USER;
		}

		public int retval;
		public rpc.policy_handle handle;
		public TypedRidArray groups;

		public SamrGetGroupsForUser(rpc.policy_handle handle,
				TypedRidArray groups) {
			this.handle = handle;
			this.groups = groups;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _groupsp = _src.dec_ndr_long();
			if (_groupsp != 0) {
				if (groups == null) { /* YOYOYO */
					groups = new TypedRidArray();
				}
				groups.decode(_ndr, _src);

			}
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class IntArray extends NdrObject {

		public int count;
		public int[] rids;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(rids, 1);

			if (rids != null) {
				_dst = _dst.deferred;
				int _ridss = count;
				_dst.enc_ndr_long(_ridss);
				int _ridsi = _dst.index;
				_dst.advance(4 * _ridss);

				_dst = _dst.derive(_ridsi);
				for (int _i = 0; _i < _ridss; _i++) {
					_dst.enc_ndr_long(rids[_i]);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _ridsp = _src.dec_ndr_long();

			if (_ridsp != 0) {
				_src = _src.deferred;
				int _ridss = _src.dec_ndr_long();
				int _ridsi = _src.index;
				_src.advance(4 * _ridss);

				if (rids == null) {
					if (_ridss < 0 || _ridss > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					rids = new int[_ridss];
				}
				_src = _src.derive(_ridsi);
				for (int _i = 0; _i < _ridss; _i++) {
					rids[_i] = (int) _src.dec_ndr_long();
				}
			}
		}
	}

	public static class SamrLookupNamesInDomain extends NdrObject {

		public int getOpnum() {
			return SAMR_LOOKUP_NAMES_IN_DOM;
		}

		public int retval;
		public rpc.policy_handle handle;
		public int count;
		public rpc.unicode_string[] names;
		public IntArray rids;
		public IntArray types;

		public SamrLookupNamesInDomain(rpc.policy_handle handle, int count,
				rpc.unicode_string[] names, IntArray rids, IntArray types) {
			this.handle = handle;
			this.count = count;
			this.names = names;
			this.rids = rids;
			this.types = types;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(count);
			int _namesl = count;
			int _namess = 1000;
			_dst.enc_ndr_long(_namess);
			_dst.enc_ndr_long(0);
			_dst.enc_ndr_long(_namesl);
			int _namesi = _dst.index;
			_dst.advance(8 * _namesl);
			_dst = _dst.derive(_namesi);
			for (int _i = 0; _i < _namesl; _i++) {
				names[_i].encode(_ndr, _dst);
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			rids.decode(_ndr, _src);
			types.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}
}
